

EffectMessage = {}
EffectMessage.new = function ( params )
	
	local this = {}
	this.className = "EffectMessage"
	this.params = paramas
	
	this.text = params.text
	this.x = params.x
	this.y = params.y
	this.font = params.font
	this.alpha = 1.0
	this.alphaDecrement = 0.02
	this.isEnd = false
	this.frameCount = 0
	
	--=========================================================
	-- 更新
	--=========================================================
	this.update = function (self)
		
		if ( self.isEnd ) then
			return
		end
		
		self.frameCount = self.frameCount + 1
		
		self.y = self.y - 1
		self.alpha = self.alpha - self.alphaDecrement
		
		if ( self.alpha < 0 ) then
			self.alpha = 0
			self.isEnd = true
		end
	end
	
	--=========================================================
	-- 描画
	--=========================================================
	this.draw = function (self)

		if ( self.isEnd ) then
			return
		end
	
		local r,g,b,a = love.graphics.getColor()
		local currentFont = love.graphics.getFont()
		
		local colors = {
			{1,0,0,self.alpha}, {0,1,0,self.alpha}, {0,0,1,self.alpha},{ 1,1,0,self.alpha }
		}
		love.graphics.setColor ( colors [ (math.ceil(self.frameCount/3))%(#colors) + 1] )
		
		love.graphics.setFont ( self.font )
		
		local w = self.font:getWidth ( self.text )
		local h = self.font:getHeight ( self.text )
		
		love.graphics.print ( self.text, self.x - w/2, self.y - h/2 )
		
		--love.graphics.rectangle( "fill", 20,50, 60,120)

		love.graphics.setFont ( currentFont )
		love.graphics.setColor ( r,g,b,a )
	end
	
	return this
end
 

