--=========================================================
--
-- アイテム
--
--=========================================================


Item = {}
Item.new = function ( itemId )
	
	local this = {}
	this.className = "Item"
	this.params = paramas
	
	this.id = itemId
	
	if ( itemId == "onigiriA" ) then
		this.spriteQuad = love.graphics.newQuad ( 1 * SPRITE_WIDTH, 5 * SPRITE_HEIGHT, SPRITE_WIDTH, SPRITE_HEIGHT, spriteSheet:getDimensions() )
	elseif ( itemId == "onigiriB" ) then
		this.spriteQuad = love.graphics.newQuad ( 2 * SPRITE_WIDTH, 5 * SPRITE_HEIGHT, SPRITE_WIDTH, SPRITE_HEIGHT, spriteSheet:getDimensions() )
	elseif ( itemId == "onigiriC" ) then
		this.spriteQuad = love.graphics.newQuad ( 3 * SPRITE_WIDTH, 5 * SPRITE_HEIGHT, SPRITE_WIDTH, SPRITE_HEIGHT, spriteSheet:getDimensions() )
	elseif ( itemId == "onigiriD" ) then
		this.spriteQuad = love.graphics.newQuad ( 4 * SPRITE_WIDTH, 5 * SPRITE_HEIGHT, SPRITE_WIDTH, SPRITE_HEIGHT, spriteSheet:getDimensions() )
	elseif ( itemId == "limitUp" ) then
		this.spriteQuad = love.graphics.newQuad ( 0 * SPRITE_WIDTH, 6 * SPRITE_HEIGHT, SPRITE_WIDTH, SPRITE_HEIGHT, spriteSheet:getDimensions() )
	elseif ( itemId == "extend" ) then
		this.spriteQuad = love.graphics.newQuad ( 0 * SPRITE_WIDTH, 7 * SPRITE_HEIGHT, SPRITE_WIDTH, SPRITE_HEIGHT, spriteSheet:getDimensions() )
	end
	
	this.x = math.random ( canvas_field:getWidth() )
	this.y = -1 * SPRITE_HEIGHT
	
	this.speed    = 3 --math.random ( 3,8 )
	--this.rotation = math.random ( -5, 5 )
	--this.angle    = math.random(360)
	
	this.isEnd = false
	
	this.angle = 0
	
	this.hitSize = 20
	this.hitOffsetX = 0
	this.hitOffsetY = 0
	
	--=========================================================
	-- 更新
	--=========================================================
	this.update = function (self)
		
		if ( self.isEnd ) then
			return
		end
		
		--self.angle = self.angle%360 + self.rotation
		
		self.y = self.y + self.speed
		if ( self.y > canvas_field:getHeight() + SPRITE_HEIGHT ) then
			
			self.isEnd = true
			
		end
		
		-- 自機との当たり判定
		if ( not playerMachine.isCrashing ) then -- 連続で当たるのも悪くないかも
			local distToPlayer = utils.getDistance ( 
				self.x + self.hitOffsetX, self.y + self.hitOffsetY, 
				playerMachine.x + playerMachine.hitOffsetX, playerMachine.y + playerMachine.hitOffsetY ) 
			
			if ( distToPlayer < ( playerMachine.hitSize + self.hitSize ) ) then
				--playerMachine:crash()
				playerMachine:getItem ( self )
			end
		end
		
		-- 岩との当たり判定
		for i = 1, #rocks, 1 do
			local rock = rocks[i]
			if ( not rock.isBanishing ) then
				local distToRock = utils.getDistance ( 
					self.x + self.hitOffsetX, self.y + self.hitOffsetY, 
					rock.x + rock.hitOffsetX, rock.y + rock.hitOffsetY ) 
				
				if ( distToRock < ( rock.hitSize + self.hitSize ) ) then
					rock:banish()
					playSound ( sounds["wrack"] )
				end
			end
		end
		
	end
	
	--=========================================================
	-- 描画
	--=========================================================
	this.draw = function (self)
	
		if ( self.isEnd ) then
			return
		end
		
		local r,g,b,a = love.graphics.getColor()
		
		love.graphics.setColor ( 1,1,1,1 )
		
		local offsetX = SPRITE_WIDTH/2
		local offsetY = SPRITE_HEIGHT/2
		
		love.graphics.draw ( spriteSheet, self.spriteQuad, self.x, self.y, math.rad(self.angle), 1.0, 1.0, offsetX, offsetY )

		if ( isHitAreaShown ) then
			love.graphics.setColor ( 1,0,0,1 )
			love.graphics.circle ( "line", self.x + self.hitOffsetX, self.y + self.hitOffsetY, self.hitSize )
		end
		
		love.graphics.setColor ( r,g,b,a )
	end
	
	return this
end
 

