--=========================================================
--
-- 岩
--
--=========================================================


Rock = {}
Rock.new = function ( params )
	
	local this = {}
	this.className = "Rock"
	this.params = paramas
	
	this.spriteQuad = love.graphics.newQuad ( 0 * SPRITE_WIDTH, 4 * SPRITE_HEIGHT, SPRITE_WIDTH, SPRITE_HEIGHT, spriteSheet:getDimensions() )

	this.spriteQuad_banish = {}
	this.spriteQuad_banish[#this.spriteQuad_banish + 1] = love.graphics.newQuad ( 1 * SPRITE_WIDTH, 4 * SPRITE_HEIGHT, SPRITE_WIDTH, SPRITE_HEIGHT, spriteSheet:getDimensions() )
	this.spriteQuad_banish[#this.spriteQuad_banish + 1] = love.graphics.newQuad ( 2 * SPRITE_WIDTH, 4 * SPRITE_HEIGHT, SPRITE_WIDTH, SPRITE_HEIGHT, spriteSheet:getDimensions() )
	this.spriteQuad_banish[#this.spriteQuad_banish + 1] = love.graphics.newQuad ( 3 * SPRITE_WIDTH, 4 * SPRITE_HEIGHT, SPRITE_WIDTH, SPRITE_HEIGHT, spriteSheet:getDimensions() )
	this.spriteQuad_banish[#this.spriteQuad_banish + 1] = love.graphics.newQuad ( 4 * SPRITE_WIDTH, 4 * SPRITE_HEIGHT, SPRITE_WIDTH, SPRITE_HEIGHT, spriteSheet:getDimensions() )
	

	this.x = math.random ( canvas_field:getWidth() )
	this.y = -1 * SPRITE_HEIGHT
	
	this.speed    = math.random ( 3,8 )
	this.rotation = math.random ( -5, 5 )
	this.angle    = math.random(360)
	
	this.isEnd = false
	this.isBanishing = false
	this.banishAnimeCount = 0
	this.banishAnimeWait = 0
	this.banishAnimeWaitMax = 2	
	
	this.angle = 0
	
	this.hitSize = 10
--	this.hitSize = 15
	this.hitOffsetX = 0
	this.hitOffsetY = 0
	
	--=========================================================
	-- 消滅
	--=========================================================
	this.banish = function (self) 
		
		--playSound ( sounds["banish"] )
		self.isBanishing = true
		self.banishAnimeCount = 1
		self.banishAnimeWait = self.banishAnimeWaitMax	
	end
	
	--=========================================================
	-- 更新
	--=========================================================
	this.update = function (self)
		
		if ( self.isEnd ) then
			return
		end
		
		if ( not self.isBanishing ) then
		
			-- 回転		
			self.angle = self.angle%360 + self.rotation
			
			-- 移動
			self.y = self.y + self.speed
			if ( self.y > canvas_field:getHeight() + SPRITE_HEIGHT ) then
				self.isEnd = true
			end
			
			-- 自機との当たり判定
			if ( not playerMachine.isCrashing and playerMachine.blownoffCount <= 0 and playerMachine.blinkCount <= 0 ) then -- 連続で当たるのも悪くないかも
				
				local distToPlayer = utils.getDistance ( 
					self.x + self.hitOffsetX, self.y + self.hitOffsetY, 
					playerMachine.x + playerMachine.hitOffsetX, playerMachine.y + playerMachine.hitOffsetY ) 
				
				if ( distToPlayer < ( playerMachine.hitSize + self.hitSize ) ) then
					--print ("当たった")
					
					--playerMachine:crash()
					playerMachine:blownoff(self)
					energy = energy - 20
				end
			end
			
		-- 消滅中
		else
			if ( self.banishAnimeWait <= 0 ) then
				self.banishAnimeCount = self.banishAnimeCount + 1
				self.banishAnimeWait = self.banishAnimeWaitMax
				
				if ( self.banishAnimeCount > #self.spriteQuad_banish ) then
					self.isEnd = true
				end
			else
				self.banishAnimeWait = self.banishAnimeWait - 1
			end
		end

	end
	
	--=========================================================
	-- 描画
	--=========================================================
	this.draw = function (self)
	
		if ( self.isEnd ) then
			return
		end
		
		local r,g,b,a = love.graphics.getColor()
		
		love.graphics.setColor ( 1,1,1,1 )
		
		local offsetX = SPRITE_WIDTH/2
		local offsetY = SPRITE_HEIGHT/2
		
		if ( self.isBanishing ) then
			love.graphics.draw ( spriteSheet, self.spriteQuad_banish[self.banishAnimeCount], self.x, self.y, math.rad(self.angle), 1.0, 1.0, offsetX, offsetY )
		else
			love.graphics.draw ( spriteSheet, self.spriteQuad, self.x, self.y, math.rad(self.angle), 1.0, 1.0, offsetX, offsetY )
		end

		if ( isHitAreaShown ) then
			love.graphics.setColor ( 1,0,0,1 )
			love.graphics.circle ( "line", self.x + self.hitOffsetX, self.y + self.hitOffsetY, self.hitSize )
		end
		
		love.graphics.setColor ( r,g,b,a )
	end
	
	return this
end
 

